/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.brooklyn.core.objs;

import java.util.Map;

import org.apache.brooklyn.api.mgmt.rebind.RebindSupport;
import org.apache.brooklyn.core.objs.AbstractEntityAdjunct;
import org.testng.annotations.Test;

import com.google.common.collect.ImmutableMap;

public class AbstractEntityAdjunctTest {
    private static class TestAdjunct extends AbstractEntityAdjunct {
        public TestAdjunct(Map<?, ?> properties) {
            super(properties);
        }
 
        @Override
        public RebindSupport<?> getRebindSupport() {
            return null;
        }

        @Override
        protected void onChanged() {
        }
    }

    @Test
    public void testImmutableFlags() {
        //shouldn't try to mutate passed flags map (or previous references to it)
        TestAdjunct testAdjunct = new TestAdjunct(ImmutableMap.of("unusedKey", "unusedValue"));
        testAdjunct.configure(ImmutableMap.of("finalKey", "finalValue"));
    }

}
